-- Lua management server
-- (c) zoner

package.path = package.path .. ';./lib/?.lua;./lib/proto/?.lua'

local D = require('d')

local task = function(self)
    print('Starting task ' .. self.n)
    while true do
        self:s(self.period); repeat self.yield() until self.D.t >= self.t
        print('task' .. self.n, self.period, self.t)
    end
end

D:addTask(task, {n=1, period=3})
D:addTask(task, {n=2, period=5})
D:addTask(task, {n=3, period=7})
D:addTask(task, {n=4, period=9})

D.serve = D.serv.serve(D.parg.get('-port',8090), './static',16, function(req,resp)
print('method:',req.method,'path:',req.path,'type:',resp.headers['Content-Type'])
    if req.method == 'GET' then
        if req.path == '/test.json' then
            resp.text = '[1,2,3,4,5]'
            resp.served = true
        end
    end
end)

repeat
    D:clock()
    for _,task in pairs(D.tasks) do task:run() end
    local status,res = D.serve()
until D.exited

D:exit()
