-- Communication channel
-- (c) zöner

local Port = {}

function Port:new()
    local o = {}
    setmetatable(o, self)
    self.__index = self
    return o
end

function Port:names() return {} end

function Port:open(name) self.name = name end
function Port:opened() return false end
function Port:close() end

function Port:avail() return 0 end

function Port:read() return '' end
function Port:write(buf) end

function Port:props() return {} end
function Port:prop(k,v) return v end

return Port
